/*******************************************************************************
 * Copyright (c) 2005 Chris Aniszczyk.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Chris Aniszczyk - updated to work with EMF
 *    IBM Corporation
 *******************************************************************************/

package org.eclipse.gef.examples.shapes.emf.model;

import java.util.Map;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.impl.XMLResourceImpl;
import org.eclipse.gef.examples.shapes.emf.model.impl.ModelPackageImpl;

public class ModelManager {

	  private static Resource resource = new XMLResourceImpl();
	  private static ModelFactory factory = getFactory();

	  /**
	   * Returns the factory associated with the model. Object creation is made
	   * through that factory.
	   */
	  public static ModelFactory getFactory() {
	    if (factory == null) {
	      ModelPackageImpl.init();
	      // Access the factory (needed to create instances)
	      Map registry = EPackage.Registry.INSTANCE;
	      String URI = ModelPackage.eNS_URI;
	      ModelPackage modelPackage = (ModelPackage) registry.get(URI);
	      factory = modelPackage.getModelFactory();
	    }
	    return factory;
	  }
	  
}
