/*******************************************************************************
 * Copyright (c) 2005 Chris Aniszczyk.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Chris Aniszczyk - updated to work with EMF
 *    IBM Corporation
 *******************************************************************************/

package org.eclipse.gef.examples.shapes.emf.model;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/** @model abstract="true" */
public interface Shape extends EObject{
	
	/** @model default="0" */
	public int getX();
	
	/**
	 * Sets the value of the '{@link org.eclipse.gef.examples.shapes.emf.model.Shape#getX <em>X</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>X</em>' attribute.
	 * @see #getX()
	 * @generated
	 */
	void setX(int value);

	/** @model default="0" */
	public int getY();
	
	/**
	 * Sets the value of the '{@link org.eclipse.gef.examples.shapes.emf.model.Shape#getY <em>Y</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Y</em>' attribute.
	 * @see #getY()
	 * @generated
	 */
	void setY(int value);

	/** @model default="50" */
	public int getWidth();
	
	/**
	 * Sets the value of the '{@link org.eclipse.gef.examples.shapes.emf.model.Shape#getWidth <em>Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Width</em>' attribute.
	 * @see #getWidth()
	 * @generated
	 */
	void setWidth(int value);

	/** @model default="50" */
	public int getHeight();
	
	/**
	 * Sets the value of the '{@link org.eclipse.gef.examples.shapes.emf.model.Shape#getHeight <em>Height</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Height</em>' attribute.
	 * @see #getHeight()
	 * @generated
	 */
	void setHeight(int value);

	/** @model type="Connection" containment="true" */
	EList getSourceConnections();
	
	/** @model type="Connection" */
	EList getTargetConnections();
	
}
